package com.jkcredit.invoice.service.nocar.impl;

import cn.com.taiji.sdk.model.comm.protocol.eoms.company.*;
import cn.com.taiji.sdk.model.comm.protocol.tts.waybill.OperatorSendCodeRequest;
import cn.com.taiji.sdk.model.comm.protocol.tts.waybill.OperatorValidCodeRequest;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.jkcredit.invoice.mapper.waybill.NoCarCompanyMangerMapper;
import com.jkcredit.invoice.model.entity.waybill.NoCarCompanyManger;
import com.jkcredit.invoice.model.vo.OperatorEditConfirmVo;
import com.jkcredit.invoice.model.vo.OperatorEditVo;
import com.jkcredit.invoice.model.vo.OperatorEvidenceVo;
import com.jkcredit.invoice.model.vo.OperatorSendCodeVo;
import com.jkcredit.invoice.service.manager.ParamService;
import com.jkcredit.invoice.service.nocar.NoCarCompanyMangerOper;
import com.jkcredit.invoice.service.upservice.NoCarInterface;
import com.jkcredit.invoice.util.RespR;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
@Slf4j
public class NoCarCompanyMangerOperImpl extends ServiceImpl<NoCarCompanyMangerMapper,NoCarCompanyManger> implements NoCarCompanyMangerOper{
    @Autowired
    private NoCarCompanyMangerMapper noCarCompanyMangerMapper;

    @Autowired
    private NoCarInterface noCarInterface;

    @Autowired
    ParamService paramService;
    @Override
    public RespR companyDetailAdd(NoCarCompanyManger noCarCompanyManger) {
        QueryWrapper<NoCarCompanyManger> queryWrapper = new QueryWrapper<>();
        queryWrapper.select("operatorMobile").eq("companyNum",noCarCompanyManger.getCompanyNum());
        NoCarCompanyManger noCarCompanyMangerDb = noCarCompanyMangerMapper.selectOne(queryWrapper);
        if(noCarCompanyMangerDb !=null){
            return new RespR(false,"已经上传企业开票人，无需重复上传");
        }
        CompanyDetailAddRequest companyDetailAddRequest = new CompanyDetailAddRequest();
        BeanUtils.copyProperties(noCarCompanyManger,companyDetailAddRequest);
        RespR<CompanyDetailAddResponse> respR = noCarInterface.companyDetailAdd(companyDetailAddRequest);
        if(respR.getCode() == 1){
            log.error("companyDetailAdd上传失败，失败原因:{}",respR.getMsg());
            return new RespR(false,respR.getMsg());
        }else{
            noCarCompanyManger.setStatus("1");
            noCarCompanyMangerMapper.insert(noCarCompanyManger);
            return new RespR("success");
        }
    }

    @Override
    public RespR operatorEdit(OperatorEditVo operatorEditVo) {
        OperatorEditRequest operatorEditRequest = new OperatorEditRequest();
        BeanUtils.copyProperties(operatorEditVo,operatorEditRequest);
        RespR respR = noCarInterface.operatorEdit(operatorEditRequest);
        if(respR.getCode() == 1){
            log.error("operatorEdit失败，失败原因:{}",respR.getMsg());
            return new RespR(false,respR.getMsg());
        }else{
            UpdateWrapper<NoCarCompanyManger> updateWrapper = new UpdateWrapper<>();
            updateWrapper.set("operatorNameTemp",operatorEditVo.getTargetOperatorName());
            updateWrapper.set("operatorMobileTemp",operatorEditVo.getSourceOperatorMobile());
            updateWrapper.set("identificationIdTemp",operatorEditVo.getTargetIdentificationId());
            updateWrapper.set("status","2");
            updateWrapper.eq("companyNum",operatorEditVo.getCompanyNum());
            NoCarCompanyManger noCarCompanyManger  = new NoCarCompanyManger();
            noCarCompanyManger.setCompanyNum(operatorEditVo.getCompanyNum());
            noCarCompanyMangerMapper.update(noCarCompanyManger,updateWrapper);
            return new RespR("success");
        }

    }

    @Override
    public RespR operatorEditConfirm(OperatorEditConfirmVo operatorEditConfirmVo) {
        OperatorEditConfirmRequest operatorEditConfirmRequest = new OperatorEditConfirmRequest();
        BeanUtils.copyProperties(operatorEditConfirmVo,operatorEditConfirmRequest);
        RespR respR = noCarInterface.operatorEditConfirm(operatorEditConfirmRequest);
        if(respR.getCode() == 1){
            log.error("operatorEditConfirm失败，失败原因:{}",respR.getMsg());
            return new RespR(false,respR.getMsg());
        }else{
            QueryWrapper<NoCarCompanyManger> queryWrapper = new QueryWrapper<>();
            queryWrapper.select("operatorNameTemp","operatorMobileTemp","identificationIdTemp").eq("companyNum",operatorEditConfirmVo.getCompanyNum());
            NoCarCompanyManger noCarCompanyMangerDb = noCarCompanyMangerMapper.selectOne(queryWrapper);
            UpdateWrapper<NoCarCompanyManger> updateWrapper = new UpdateWrapper<>();
            updateWrapper.set("operatorName",noCarCompanyMangerDb.getOperatorNameTemp());
            updateWrapper.set("operatorMobile",noCarCompanyMangerDb.getOperatorMobileTemp());
            updateWrapper.set("identificationId",noCarCompanyMangerDb.getIdentificationIdTemp());
            updateWrapper.set("status","1");
            updateWrapper.eq("companyNum",operatorEditConfirmVo.getCompanyNum());
            noCarCompanyMangerMapper.update(noCarCompanyMangerDb,updateWrapper);
            return new RespR("success");
        }
    }

    @Override
    public RespR operatorEvidence(OperatorEvidenceVo operatorEvidenceVo) {
        OperatorEvidenceRequest operatorEvidenceRequest = new OperatorEvidenceRequest();
        BeanUtils.copyProperties(operatorEvidenceVo,operatorEvidenceRequest);
        RespR respR = noCarInterface.operatorEvidence(operatorEvidenceRequest);
        if(respR.getCode() == 1){
            log.error("operatorEvidence失败，失败原因:{}",respR.getMsg());
            return new RespR(false,respR.getMsg());
        }else{
            UpdateWrapper<NoCarCompanyManger> updateWrapper = new UpdateWrapper<>();
            updateWrapper.set("contractFileName",operatorEvidenceVo.getContractFileName());
            updateWrapper.set("base64Str",operatorEvidenceVo.getBase64Str());
            updateWrapper.eq("companyNum",operatorEvidenceVo.getCompanyNum());
            NoCarCompanyManger noCarCompanyManger  = new NoCarCompanyManger();
            noCarCompanyManger.setCompanyNum(operatorEvidenceVo.getCompanyNum());
            noCarCompanyMangerMapper.update(noCarCompanyManger,updateWrapper);
            return new RespR("success");
        }
    }

    @Override
    public RespR operatorSendCode(OperatorSendCodeVo operatorSendCodeVo) {
        OperatorSendCodeRequest operatorSendCodeRequest = new OperatorSendCodeRequest();
        operatorSendCodeRequest.setBuyerCode(operatorSendCodeVo.getBuyerCode());
        String companyNum = paramService.getParamsByParamName("REQUEST_COMPANY_NUM").getParamValue();
        operatorSendCodeRequest.setCompanyNum(companyNum);
        RespR respR = noCarInterface.operatorSendCode(operatorSendCodeRequest);
        if(respR.getCode()==1){
            return new RespR(false,respR.getMsg());
        }else {
            return new RespR("success");
        }
    }

    @Override
    public RespR operatorValidCode(OperatorSendCodeVo operatorSendCodeVo) {
        OperatorValidCodeRequest operatorValidCodeRequest = new OperatorValidCodeRequest();
        operatorValidCodeRequest.setBuyerCode(operatorSendCodeVo.getBuyerCode());
        String companyNum = paramService.getParamsByParamName("REQUEST_COMPANY_NUM").getParamValue();
        operatorValidCodeRequest.setCompanyNum(companyNum);
        operatorValidCodeRequest.setValidCode(operatorSendCodeVo.getValidCode());
        RespR respR = noCarInterface.operatorValidCode(operatorValidCodeRequest);
        if(respR.getCode()==1){
            return new RespR(false,respR.getMsg());
        }else {
            return new RespR("success");
        }
    }
}
